package com.ruoyi.bst.vipUser.service;

import java.util.List;

import com.ruoyi.bst.vipOrder.domain.VipOrder;
import com.ruoyi.bst.vipUser.domain.VipUser;
import com.ruoyi.bst.vipUser.domain.VipUserQuery;
import com.ruoyi.bst.vipUser.domain.VipUserVO;

/**
 * 用户卡券Service接口
 *
 * @author ruoyi
 * @date 2025-05-26
 */
public interface VipUserService
{
    /**
     * 查询用户卡券
     *
     * @param id 用户卡券主键
     * @return 用户卡券
     */
    public VipUserVO selectVipUserById(Long id, boolean scope);

    default VipUserVO selectVipUserById(Long id) {
        return selectVipUserById(id, false);
    }

    /**
     * 查询用户卡券列表
     *
     * @param vipUser 用户卡券
     * @return 用户卡券集合
     */
    public List<VipUserVO> selectVipUserList(VipUserQuery vipUser);

    /**
     * 新增用户卡券
     *
     * @param vipUser 用户卡券
     * @return 结果
     */
    public int insertVipUser(VipUser vipUser);

    /**
     * 修改用户卡券
     *
     * @param vipUser 用户卡券
     * @return 结果
     */
    public int updateVipUser(VipUser vipUser);
    
    /**
     * 查询可兼容的VIP
     * @param order
     * @return
     */
    public VipUserVO selectUserSameVip(VipOrder order);

    /**
     * 续费
     * @param id VIP用户ID
     * @param days 续费时长
     * @param total 续费次数
     * @return
     */
    public int renew(Long id, Long days, Integer total);

    /**
     * 逻辑删除
     * @param ids
     * @return
     */
    public int logicDel(List<Long> ids);

    /**
     * 恢复VIP优惠次数
     * @param vipUserId
     * @return
     */
    public int recoverVipCount(Long vipUserId, int count);

    /**
     * 扣减VIP优惠次数
     * @param id
     * @param count
     * @return
     */
    public int deductVipCount(Long id, int count);

    /**
     * 刷新卡券周期计数
     * @param vipUser
     * @return
     */
    public int resetVipRoundCount(VipUserVO vipUser);

}
